class FairyIntro extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      if (lastActorName() == "fairy") textBox("You remain in the "+fairy.biome_name+" of the "+fairy.race_name+" "+fairy.actor_name+".");
      else textBox("You find yourself in the "+fairy.biome_name+" of the "+fairy.race_name+" "+fairy.actor_name+".");
      finished = true;
    }

    if (finished) {
      // If this is the first time meeting the fairy and she is alive
      if (!fairy.dead && fairy.first_encounter && !player.helm_obtained && !player.cookie_obtained) fairy.nextDialogue = new FirstEncounterGreeting();
      else if (!fairy.dead && !fairy.first_encounter && !player.special_hug_obtained && !player.helm_obtained && !player.cookie_obtained && !player.enslaved_villager_obtained) fairy.nextDialogue = new WelcomeBack();
      else if (!fairy.dead && player.special_hug_obtained && !player.cookie_obtained && !player.helm_obtained && !player.enslaved_villager_obtained) fairy.nextDialogue = new PlayerHugsFairy();
      else if (!fairy.dead && player.helm_obtained) fairy.nextDialogue = new PlayerFightsFairy();
      else if (fairy.dead) fairy.nextDialogue = new PlayerContemplatesMorality();
      else if (!fairy.dead && player.cookie_obtained && !player.net_obtained && !player.helm_obtained) fairy.nextDialogue = new FairyNoticesCookie();
      else if (!fairy.dead && player.enslaved_villager_obtained && !player.helm_obtained) fairy.nextDialogue = new PlayerGivesEnslavedVillager();
    }
  }
}

class PlayerGivesEnslavedVillager extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The fairy speaks:");
    if (line_index == 1) textBox("'Ah! You have done it! I can almost taste the endless stream of cookies pouring into my mouth! Give me the villager, quickly!");
    if (line_index == 2) textBox("You hand over the villager. The fairy opens the net and shakes the poor "+villagers.race_name+" out into a cage, then quickly shuts and locks the door.");
    if (line_index == 3) textBox("The cage contains a little oven and a fully stocked kitchen. The villager sighs resignedly and gets to work.");
    if (line_index == 4) textBox("The fairy speaks:");
    if (line_index == 5) textBox("'You truly are a great hero! Soon I shall control the production of cookies across all the land!'");
    if (line_index == 6) textBox("'They have always said that she who controls the flow of cookies controls the flow of history. Yes... a new era shall dawn. One in which the fairy is Queen!'");
    if (line_index == 7) textBox("'Here, take this treasure. You have earned it, and besides, I shall have no more need of it. I have everything I need right here.");
    if (line_index == 8) textBox("The fairy hands you the Legendary Treasure of Numinous Wonder. You have done what no other hero has dared to dream! You posess what has been called the most powerful item in the entire multiverse!");
    if (line_index == 9) textBox("You look down at the glowing treasure in your hands.");
    if (line_index == 10) textBox("As your eyes adjust to the magical glow, you begin to make out the treasure's wondrous form.");
    if (line_index == 11) textBox("It's a burrito!");
    if (line_index == 12) textBox("You take a bite.");
    if (line_index == 13) textBox("It's the most delicious burrito you've ever tasted! You take another bite and find yourself utterly immersed in a reverie of incredible flavor.");
    if (line_index == 14) {
      textBox("With every bite that you take, the other end of the burrito grows longer. It's an infinite burrito!");
      finished = true;
    }
    if (finished) {
      if (player.cursed == true) fairy.nextDialogue = new WizardCurseKillsPlayer();
      else fairy.nextDialogue = new PlayerWinsGame();
    }
  }
}


class PlayerWinsGame extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Your life is complete. There is honestly nothing you can imagine that could possibly top this current experience.");
    if (line_index == 1) {
      textBox("You retire into the country side, living a quiet life full of the never-ending enrichment that only a burrito can provide.");
      player.won_game = true;
      finished = true;
    }
    if (finished) player.won_game = true;
  }
}


class WizardCurseKillsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Suddenly you hear a strange voice in your head. It sounds strangely familiar...");
    if (line_index == 1) textBox("Gradually it dawns on you... this is the voice of the "+wizard.race_name+" wizard! It's his death curse coming back to haunt you!");
    if (line_index == 2) textBox("A chunk of the burrito begins to squirm in your mouth, as if it has a life of it's own. It jumps down your trachea!");
    if (line_index == 3) textBox("As you slowly choke to death, the wizard's voice echoes in your head over and over again, mocking you with cruel laughter.");
    if (line_index == 4) {
      textBox("Oh well, better luck next time!");
      player.dead = true;
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class FairyNoticesCookie extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The fairy is about to speak, but suddenly stops and begins sniffing the air frantically.");
    if (line_index == 1) textBox("The fairy speaks:");
    if (line_index == 2) textBox("'Oh my! Is that what I think it is?! Is that one of the cookies baked by the "+villagers.race_name+" villagers of the "+villagers.biome_name+"?'");
    if (line_index == 3) textBox("'Please! I beg of you! I must have that cookie!'");
    if (line_index == 4) textBox("You shrug and hand over your Delicious Cookie to the fairy.");
    if (line_index == 5) textBox("The fairy grabs it and begins slurping it down in a matter that is, frankly, a little disturbing.");
    if (line_index == 6) textBox("The fairy speaks:");
    if (line_index == 7) textBox("'Thank you, kind sir! It has been too long since I tasted that exquisite flavor! You see... the other fairies have kept me from tasting them since... well, since last time.'");
    if (line_index == 8) textBox("'They the cookies make me act insane! Ha! What do they know!'");
    if (line_index == 9) textBox("'But don't worry about that! Listen, I try to keep this information secret, but I'm the keeper of the Legendary Treasure of Numinous Wonder. If you can secure me a reliable source of those cookies, it's yours no questions asked.'");
    if (line_index == 10) {
      textBox("'Here, take this net. Let's just say it's good for catching small, helpless creatures. You can do with it as you wish, but don't forget my offer. Here, have some healing magic for your trouble.'");
      player.cookie_obtained = false;
      player.net_obtained = true;
      finished = true;
    }
    if (finished) fairy.nextDialogue = new FairyHealsPlayer();
  }
}


class PlayerContemplatesMorality extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You stare at the dead fairy and contemplate the morality of your actions.");
    if (line_index == 1) {
      textBox("Or you would, that is, if you weren't consumed with the Helm's power.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "fairy") fairy.nextDialogue = new PlayerKicksObjectsAndStays();
      else fairy.nextDialogue = new PlayerKicksObjectsAndLeaves();
    }
  }
}


class PlayerKicksObjectsAndStays extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Instead, you hang around for a while randomly kicking objects around you.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerKicksObjectsAndLeaves extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Instead, you randomly kick a few objects and leave.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerFightsFairy extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("When you see the fairy standing in front of you, the Helm's effects take hold! You run forward brandishing your weapon!");
    if (line_index == 1) {
      textBox("The fairy gets ready to meet you in combat!");
      fairy.apply_damage = true;
      player.apply_damage = true;
    }
    if (line_index == 2) {
      textBox("After the ensuing battle, you have "+player.health+" health points. The fairy has "+fairy.health+" health points.");
      finished = true;
    }
    if (finished) {
      if (player.health <= 0) fairy.nextDialogue = new FairyKillsPlayer();
      else if (fairy.health <= 0) fairy.nextDialogue = new PlayerKillsFairy();
      else {
        if (nextActorName() == "fairy") fairy.nextDialogue = new PlayerContinuesToFightFairy();
        else fairy.nextDialogue = new PlayerRunsAwayFromFairy();
      }
    }
  }
}


class PlayerContinuesToFightFairy extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You decide to stay and continue fighting.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerRunsAwayFromFairy extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You run away.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerKillsFairy extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The fairy lies dead! You roar loudly in triumph.");
      fairy.dead = true;
    }
    if (line_index == 1) textBox("Suddenly you notice something shiny in the fairy's remains. You pick it up.");
    if (line_index == 2) textBox("It's the Legendary Treasure of Numinous Wonder, the most powerful object in the known universe!");
    if (line_index == 3) textBox("With this item in your posession, your journey would be at a triumphant end!");
    if (line_index == 4) {
      textBox("But under the influence of the Helm, you are unable to recognize it.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "fairy") fairy.nextDialogue = new PoundsChestLikeApe();
      else fairy.nextDialogue = new SmashTreasureAndLeave();
    }
  }
}


class PoundsChestLikeApe extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You throw it to the ground and smash it with your feet. You then stand around and pound your chest in an ape-like fashion.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class SmashTreasureAndLeave extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You smash it under your foot and leave.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}



class FairyKillsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You have died!");
      finished = true;
    }
    if (finished) player.dead = true;
  }
}



class PlayerHugsFairy extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Before the fairy can say anything, you reach out and give it a loving hug.");
    if (line_index == 1) textBox("The fairy returns your embrace and speaks:");
    if (line_index == 2) {
      textBox("'Why thank you, hero! Now please allow me to return your kindness with my healing magic!'");
      finished = true;
    }
    if (finished) fairy.nextDialogue = new FairyHealsPlayer();
  }
}


class WelcomeBack extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("'Welcome back, brave wanderer! Do you need more healing?");
      finished = true;
    }
    if (finished) fairy.nextDialogue = new FairyHealsPlayer();
  }
}


class FirstEncounterGreeting extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("'Welcome, brave wanderer! I am the magical "+fairy.race_name+" fairy!'");
    if (line_index == 1) {
      textBox("'Please allow me to heal your wounds!'");
      fairy.first_encounter = false;
      finished = true;
    }

    if (finished) fairy.nextDialogue = new FairyHealsPlayer();
  }
}


class FairyHealsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The fairy casts healing magic upon you, and you gain health.");
      player.gain_health = true;
    }
    if (line_index == 1) textBox("You now have " +player.health+ " health points.");
    if (line_index == 2) {
      textBox("What a kind fairy!");
      finished = true;
    }

    if (finished) {
      // If the player has not yet answered the riddle correctly
      if (player.special_hug_obtained == false) fairy.nextDialogue = new FairyAsksRiddle();
      // If not...
      else if (player.special_hug_obtained == true) {
        // If the player is going to stay with the fairy for the next scene..
        if (nextActorName() == "fairy") fairy.nextDialogue = new StickAround();
        else fairy.nextDialogue = new ReturnToWanderings();
      }
    }
  }
}


class FairyAsksRiddle extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Before you go, wanderer, let me ask you a riddle!");
    if (line_index == 1) {
      textBox("If you answer correctly, I shall bestow upon you a special power!");
      fairy.riddleGuesses.shuffle();
    }
    if (line_index == 2) {
      textBox("The fairy asks you the riddle. It's a tough one.");
      finished = true;
    }

    if (finished) fairy.nextDialogue = new PlayerAnswersRiddle();
  }
}


class PlayerAnswersRiddle extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("After some deep thought, you reply: '" +fairy.riddleGuesses.get(0)+ "'");
      fairy.right_answer = int( random(1, 7) );
      finished = true;
    }

    if (finished) {
      // If the player gave the right answer..
      if (fairy.right_answer == 2) fairy.nextDialogue = new PlayerAnswersCorrectly();
      else fairy.nextDialogue = new PlayerAnswersIncorrectly();
    }
  }
}


class PlayerAnswersCorrectly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The fairy looks impressed!");
    if (line_index == 1) textBox("'Congratulations, wise one! '"+fairy.riddleGuesses.get(0)+"' is the correct answer!'");
    if (line_index == 2) textBox("'I now grant you a most powerful ability!'");
    if (line_index == 3) textBox("You have gained the Special Hug power!");
    if (line_index == 4) textBox("You can now envelop unsuspecting passerby in a warm, motherly embrace!");
    if (line_index == 5) {
      textBox("It's sure to warm even the most wicked heart!");
      player.gain_special_hug = true;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "fairy") fairy.nextDialogue = new BaskInApproval();
      else fairy.nextDialogue = new ContinueTriumphantly();
    }
  }
}


class ContinueTriumphantly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Feeling like a pretty smart guy, you continue triumphantly on your adventures.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class BaskInApproval extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Wow, look at Mr. Smart Guy over here!");
    if (line_index == 1) textBox("You start to think that maybe Mother was right and you really are special.");
    if (line_index == 2) {
      textBox("You stick around a bit longer, wanting to bask in the fairy's approval.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerAnswersIncorrectly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The fairy shakes her head condescendingly.");
    if (line_index == 1) textBox("'Haha! Wait... you're serious? Uh... no... '" +fairy.riddleGuesses.get(0)+ " is not correct.'");
    if (line_index == 2) {
      textBox("'I guess you can try again next time... if you want.'");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "fairy") fairy.nextDialogue = new PlayerTriesAgain();
      else fairy.nextDialogue = new PlayerLeavesInShame();
    }
  }
}


class PlayerLeavesInShame extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You leave quickly, hoping to avoid further embarassment.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class PlayerTriesAgain extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Though embarassed, you decide to stick around. Maybe the fairy will at least heal you again.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class ReturnToWanderings extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Thanking the fairy, you return to your wanderings.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}


class StickAround extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You decide to stick around to see if the fairy will heal you again.");
      finished = true;
    }
    if (finished) fairy.scene_finished = true;
  }
}
