class VillagersIntro extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      if (lastActorName() == "villagers") textBox("You remain in the "+villagers.biome_name+" of the "+villagers.race_name+" "+villagers.actor_name+".");
      else textBox("You find yourself in the "+villagers.biome_name+" of the "+villagers.race_name+" "+villagers.actor_name+".");
      finished = true;
    }
    if (finished) {
      if (!villagers.dead && player.helm_obtained) villagers.nextDialogue = new PlayerSlaughtersVillagers();
      else if (!villagers.dead && player.special_hug_obtained && !player.cookie_obtained && !player.helm_obtained && !player.net_obtained && !villagers.chief_dead) villagers.nextDialogue = new PlayerHugsVillageChief();
      else if (!villagers.dead && villagers.first_encounter && !monster.dead) villagers.nextDialogue = new VillagersFirstEncounterDialogue();
      else if (monster.dead && !villagers.dead && !player.helm_obtained && !player.net_obtained && !player.cookie_obtained) villagers.nextDialogue = new PlayerAnnouncesTriumph();
      else if (!villagers.dead && player.cookie_obtained && !player.net_obtained && !villagers.chief_dead) villagers.nextDialogue = new VillagersCannotOfferAnythingElse();
      else if (villagers.dead && villagers.chief_dead && monster.dead && !player.helm_obtained && !player.net_obtained) villagers.nextDialogue = new PlayerCautiouslyAnnouncesTriumph();
      else if (villagers.dead && !player.net_obtained) villagers.nextDialogue = new VillageIsDeserted();
      else if (!villagers.dead && lastActorName() == "villagers" && !player.helm_obtained && !player.special_hug_obtained && !monster.dead) villagers.nextDialogue = new VillagerSobsQuietly();
      else if (!villagers.dead && !villagers.chief_dead && !player.helm_obtained && !player.net_obtained && !player.special_hug_obtained && !villagers.first_encounter) villagers.nextDialogue = new VillageElderBugsPlayer();
      else if (!player.helm_obtained && !player.enslaved_villager_obtained && player.net_obtained) villagers.nextDialogue = new PlayerUsesNet();
      else villagers.nextDialogue = new VillageIsDeserted();
    }
  }
}


class PlayerUsesNet extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You enter the village.");
    if (line_index == 1) {
      if (villagers.dead || villagers.chief_dead) textBox("Everybody is still hiding from you. You hear a rustling sound in a nearby bush. Just then, you realize why the fairy gave you the net.");
      else {
        if (monster.dead) textBox("The villagers crowd around you in admiration. You can smell cookies baking in the distant houses. Suddenly it occurs to you why the fairy gave you the net.");
        else textBox("The villagers look at you mournfully. You can smell cookies baking in the distant houses. Suddenly you realize why the fairy gave you a net.");
      }
    }
    if (line_index == 2) {
      if (villagers.dead || villagers.chief_dead) textBox("You throw a stone into the bush to scare the villager out of hiding. As soon as it emerges, you toss out the fairy's net. It works! The villager is totally trapped!");
      else textBox("You take out the net. The villagers look at it confusedly. You feel a little bad as you toss out the net and ensnare the nearest "+villagers.race_name+". The rest of the villagers let out shocked yelps and run into their houses.");
    }
    if (line_index == 3) {
      if (nextActorName() == "villagers") textBox("Just for fun, you spend some time poking the ensnared villager.");
      else textBox("You grab up the enslaved villager and go off on your way.");
      player.enslaved_villager_obtained = true;
      villagers.dead = true;
      player.enslaved_villager_obtained = true;
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class VillageElderBugsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Not these depressing villagers again! You were just starting to mellow out after the last time you ran into them.");
    if (line_index == 1) textBox("You try to casually walk away, but they have already noticed you.");
    if (line_index == 2) textBox("The village chief calls out to you:");
    if (line_index == 3) textBox("'Oh great warrior! Have you killed the monster yet? Please! You are our only hope!'");
    if (line_index == 4) {
      textBox("You're really getting sick of this guy's endless nagging. Can't he see that you're busy with important tasks?");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerTriesToChangeTheSubject();
      else villagers.nextDialogue = new PlayerMakesVagueExcuses();
    }
  }
}


class VillagerSobsQuietly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You stand around with the villagers hoping someone will break the ice. They all seem pretty upset by the whole monster situation and no one's talking.");
    if (line_index == 1) {
      textBox("One of them begins sobbing quietly. Things are getting awkward fast.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerDoesntFeelLikeWalking();
      else villagers.nextDialogue = new PlayerSlipsAwayQuietly();
    }
  }
}


class PlayerSlipsAwayQuietly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("On second thought, it's probably time to get out of here.");
    if (line_index == 1) {
      textBox("You wait until the villagers are more completely distracted by their sadness and slip away quietly.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerDoesntFeelLikeWalking extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("This is a pretty depressing situation. You would leave, but you just don't feel like walking anywhere right now. Maybe the villagers will start to cheer up if you wait around for a while.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerCautiouslyAnnouncesTriumph extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You enter the village and cautiously announce your triumph over the monster, not sure if it will be enough to smooth over the whole complication from earlier.");
    if (line_index == 1) {
      textBox("No one makes so much as a noise.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerTriesAnnouncingAgain();
      else villagers.nextDialogue = new PlayerLeavesQuickly();
    }
  }
}


class PlayerLeavesQuickly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You leave quickly.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerTriesAnnouncingAgain extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Perhaps the villagers just didn't hear you. You decide to try again.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class VillagersCannotOfferAnythingElse extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The village chief calls out to you:");
    if (line_index == 1) {
      textBox("'Welcome back, great hero! While we are overjoyed to see you in our village again, we cannot offer you anything but our thanks as we have already given you all that we can spare.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerEnjoysBeingAdored();
      else villagers.nextDialogue = new PlayerLeavesInAHuff();
    }
  }
}


class PlayerLeavesInAHuff extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("What a bunch of ungrateful little jerks! You leave in a huff.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerEnjoysBeingAdored extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Being appreciated by these villagers is good for your self esteem. you decide to stay for a little while longer.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class VillageIsDeserted extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The village is deserted and eerily quiet.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerEnjoysSilence();
      else villagers.nextDialogue = new PlayerLeavesQuicklyUnsure();
    }
  }
}


class PlayerLeavesQuicklyUnsure extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You leave quickly, not sure why you came back in the first place.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerEnjoysSilence extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You stay for a while, enjoying the silence.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerAnnouncesTriumph extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("As you enter the "+villagers.biome_name+", you loudly announce your triumph over the monster which had been plaguing the villagers.");
    if (line_index == 1) textBox("You revel in their joyous shouts and tears of relief.");
    if (line_index == 2) textBox("The village chief calls out to you:");
    if (line_index == 3) textBox("'Oh thank you, great warrior! You truly are the hero of this age!'");
    if (line_index == 4) {
      textBox("'Though we don't have much to give you, please accept this Delicious Cookie as our payment!");
      player.cookie_obtained = true;
    }
    if (line_index == 5) {
      textBox("You have to admit that you were hoping for something more valuable, but you accept the cookie anyway.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerSoaksInVillagersLove();
      else villagers.nextDialogue = new PlayerTakesCookieAndLeaves();
    }
  }
}


class PlayerTakesCookieAndLeaves extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You tuck it into your pocket and leave.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerSoaksInVillagersLove extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("It's been so long since your deeds were validated by the approval of others. You decide to stay for a while to soak in the villagers love for you.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerHugsVillageChief extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("As soon as you see the miserable little villagers, you know exactly what to do to lift their spirits. Special Hug activate!");
    if (line_index == 1) textBox("You grab the village elder and squeeze him in the most loving way possible.");
    if (line_index == 2) textBox("Suddenly you hear a sickening snapping sound and he cries out in pain. It seems that his tiny body couldn't take the force of your hug!");
    if (line_index == 3) {
      textBox("You drop his now lifeless body and back away in horror.");
      villagers.chief_dead = true;
      finished = true;
    }
    if (finished) {
      if (player.cookie_obtained == true) villagers.nextDialogue = new PlayerUttersMeekly();
      else villagers.nextDialogue = new VillagerOffersCookieInTerror();
    }
  }
}


class PlayerUttersMeekly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The other villagers shriek in terror and scatter off in all directions.");
    if (line_index == 1) {
      if (nextActorName() == "villagers") textBox("You utter a meek apology into the now empty "+villagers.biome_name+".");
      else textBox("You utter a meek apology into the now deserted village and leave as quickly as possible.");
      villagers.dead = true;
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}



class VillagerOffersCookieInTerror extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The other villagers skriek in terror and scatter off in all directions.");
    if (line_index == 1) textBox("One of the villagers calls out to you:");
    if (line_index == 2) textBox("'Please, don't hurt us! We beg of you! Just take this Delicious Cookie and leave us in peace!'");
    if (line_index == 3) {
      textBox("She grovels in front of you and holds out the cookie in offering.");
      player.cookie_obtained = true;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerCantFindApology();
      else villagers.nextDialogue = new PlayerBacksAwaySlowly();
    }
  }
}


class PlayerBacksAwaySlowly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You take the cookie and then back away slowly, leaving the "+villagers.biome_name+" as casually as possible");
      villagers.dead = true;
      finished = true;
    }
    if (finished) {
      villagers.dead = true;
      villagers.scene_finished = true;
    }
  }
}


class PlayerCantFindApology extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You take the cookie and stand there awkwardly trying to come up with a fitting apology.");
      villagers.dead = true;
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerSlaughtersVillagers extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The helm kicks in as soon as you lay your eyes on the pitiful villagers.");
    if (line_index == 1) {
      textBox("You let out an angry roar and start slaughtering everyone you see.");
      villagers.dead = true;
    }
    if (line_index == 2) {
      textBox("It isn't long before the every villager within your eye sight is dead. You feel a vague sense of guilt which is quickly drowned out by the Helm's power.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerChewsOnSword();
      else villagers.nextDialogue = new PlayerLumbersOutOfVillage();
    }
  }
}


class PlayerLumbersOutOfVillage extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You lumber out of the "+villagers.biome_name+" mumbling angry-sounding jibberish.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerChewsOnSword extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You yell and then spend some time chewing visciously on your sword.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class VillagersFirstEncounterDialogue extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The village chief calls out to you:");
    if (line_index == 1) textBox("'O great warrior! Our people are in need of your skill!'");
    if (line_index == 2) textBox("'The "+monster.race_name+" monster of the "+monster.biome_name+" has been murdering our people. It killed my daughter!'");
    if (line_index == 3) {
      textBox("'We beg of you! Go and slay the monster and our people shall be forever in your debt!'");
      villagers.first_encounter = false;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "villagers") villagers.nextDialogue = new PlayerThinksVillagersAreCoolGuys();
      else villagers.nextDialogue = new VillagersAreHarshingPlayersMellow();
    }
  }
}


class PlayerMakesVagueExcuses extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You make some vague excuses and leave hurriedly.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class PlayerTriesToChangeTheSubject extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You keep talking and try to change the subject. It doesn't work.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}


class VillagersAreHarshingPlayersMellow extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("These villagers are really starting to harsh your mellow with their loud pleading. You wish they'd just take a chill pill and relax for a while.");
    if (line_index == 1) {
      textBox("You find an opportunity to slip out without making things too awkward.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}



class PlayerThinksVillagersAreCoolGuys extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("These villagers seem like cool guys. You decide to hang out with them for a while.");
      finished = true;
    }
    if (finished) villagers.scene_finished = true;
  }
}
